/*
 * $Id: echo.S,v 1.1.1.1 2007/09/18 14:31:52 ydong Exp $
 * User thread for miniOS: Get and print current thread ID 
 * Example for software isolated. Call function printchar.
 * All the echo tasks run in real mode and the privilage level.
 * They also share memory (curr_thrd TCB) with kernel task/handler
 * Key of certification: interrupt + concurrency + function call
 * Each cabin has 3 thread: id = 1,2,3. There are 4 cabins: id= 1~4
 * We show: cabin_id * 3 + thread_id
 */
.text                                   # Code segment
.code16                                 # Real mode
.globl	echo				# Globle, so others can call it

echo:					
	call	rgc_cli			# critical regin, access TCB->ID
	movw	(curr_thrd), %bx	# share curr_thrd/TCB with handler
	movw	TCB_ID(%bx), %ax	# read thread_ID
	call	rgc_sti			# read ID critical regin out
	movw	%ax,%dx			# dx = curr_thread_id
	addw	$0x30, %dx		# add 0x30 be a ASCII code:123

	call	rgc_get_curr_cabin_ID	# get current babin ID to show it
	addw	$0x40,%ax		# change to ASCII code: ABCD
echo_loop:
	pushw	%ax			# print the cabin ID
	call	printchar		# printchar(%ax)
	addw	$0x2, %sp		# reverse stack for %ax

	pushw	%dx			# print the thread ID
	call	printchar		# printchar(%dx)
	addw	$0x2, %sp		# reverse stack for %dx
	jmp	echo_loop
