/*
 * $Id: kernel.S,v 1.6 2007/10/05 19:39:28 ydong Exp $
 * miniOS Kernel: Timer(scheduler)
 * See: Certified  Concurrent Code with Interrupts AIM2's timer handler
 * Key for verfification: interrupt + function call, AIM2
 */
.data					# data section
	.set PRIORITY,10		# thread priority, default=10
counter:				# thread counter, initial to 0
	.word 0				# increase every timer interrupt
					# ==PRIORITY, thread schedule out
.text					# Code section
.code16					# Real mode
.globl  _start                          # entry poine should be globle
.globl	timer
.globl	timer_quit
/*
 * Entry point: the first instruction to execute
 * Main flow of system initilization: interrupt, memory, threads(idle, echos)
 */
# precondition: interrupt is turned off, init critical region in
_start:
	call	rgc_cli			# ranger call to turn interrupt off
        #** rg_call01 interupt_init, call    interrupt_init          # initialize timer interrupt handler
        # precondition: sp = 0xfffe, ss = 0x9000
        call    fTCBs_init              # initialize free_TCBs
        call    idle_init               # initilize idle thread
	call	rgc_sti			# init critial region out, have idle
        pushw   $echo                   # parameter of spawn
        call    spawn                   # spawn MAX_THRD_NUM - 1 echos
        addw    $2, %sp                 # AIM2 bootup finished
idle:					# infinite idle loop, waiting for timer
	jmp	idle			# idle thread will be switch out here

/* Timer interrupt handler, system heart beat, call scheduler here */
# precondition: interrupt is truned off, (pi, gi)
timer:					# h_entry
        pushw   %ax                     # interrupt context save: reg => stack
        pushw   %bx
        pushw   %cx
        pushw   %dx
        pushw   %di
        pushw   %si
        pushw   %bp
	#** rg_call02 initerrupt_ack
        #movw    $0x20, %dx
        #movb    $0x20, %al
        #outb    %al, %dx                # send EOI, interrupt ACK

	movw	(counter), %cx		# read counter
	cmpw	$PRIORITY, %cx		# if (counter == PRIORITY) do scheudle
	je	do_schedule
	addw	$1, %cx			# counter ++
	movw	%cx,(counter)		# write counter back

timer_quit:				# scheduled thread runs form here
        popw    %bp			# interrupt context load: stack => reg
        popw    %si
        popw    %di
        popw    %dx
        popw    %cx
        popw    %bx
        popw    %ax
	#** rg_call02 interrupt_ret
        iret				# schedule critical region out

do_schedule:
	movw	$0, %ax			# reset counter and schedule
	movw	%ax, (counter)		# counter = 0
        call    scheduler
	jmp	timer_quit
