/*
 * $Id: scheduler.S,v 1.1.1.1 2007/09/18 14:31:52 ydong Exp $
 * RR Scheduler of miniOS, called by timer interrupt handler 
 * Precondition: interrupt is turn off
 */
.text					# Code segment
.code16					# Real mode
.globl	scheduler

/* scheduler framework: schedule algurithm implemented in find_next_thrd*/
scheduler:
        movw    (curr_thrd), %bx	# save_context(curr_thrd)
        movw    %sp, TCB_STACK(%bx)	# Stack point sp --> timer_quit
	call 	save_curr_thrd		# save current thread
	call 	find_next_thrd		# get next ready thrd, may be curr/idle
	movw	%ax, %bx		# load_context(ra)
        movw    %ax, (curr_thrd)	# ra of find_next_fhrd:  selected thrd
        movw    TCB_STACK(%bx), %sp	# set stack for selected thread
        retw

/* save curr_thrd into readyQ for RR scheduler. Others may change TCB */
save_curr_thrd:
        movw    (curr_thrd), %bx	# curr_thrd
	movw	(idle_thrd), %ax	# idle_thrd 
	cmpw	%bx, %ax
	je	save_done		# idle will not be put in readyQ
	pushw	$readyQ
        pushw   %bx
        call    enQueue			# enQueue(&curr_thrd, &readyQ)
        addw    $4, %sp			# put curr_thrd back into readyQ
save_done:
	retw

/* find next thrd from readyQ. RR scheduler. Others may read TCB */
find_next_thrd:				# schedule algurithm should be here
	pushw	$readyQ			# find next thread to run
        call    deQueue 		# $readyQ is on the top of stack now
        addw    $2, %sp			# recover parameter 1 $readyQ
        cmpw    $0, %ax			# return value, ax = selected thread
        je	find_nothing
	retw				# got a ready thread, switch it in
find_nothing:
	movw	(idle_thrd), %ax	# enmpty readyQ. run idle, never be here
	retw
