/*
 * $Id: init.S,v 1.6 2007/12/09 22:43:15 ydong Exp $
 * toy hypervisor (Ranger) initial file
 * Hypervisor, named Ranger; each miniOS, named Cabin.
 * Initial functions: interrupt handle, memory(free CCBs), Cabins(miniOSs)
 * precondition for all the functions: interrupt is turned off
 */
	.set	NTIMER_IP, 4*32		# PIC constant for timer interrupt
	.set	NTIMER_CSEG, NTIMER_IP + 2
	.set	PREEMPT_TICS, 11932	# Timer 1193180/11932 = 100 Hz
	.set	DEFAULT_MASK, 0xfe	# interrupt mask allowing only timer

    	.set    CSTACK_SZ, 0x400	# 1 kilo stack for each Cabin
    	.set    CSTACK_BOTTOM, 0xfffe
    	.set    CSTACK_SEGMENT, 0x9000	# initial stack segment for ranger
    	.set    CDATA_SEGMENT, 0x0000	# initial stack segment for ranger

	.set	MAX_CABIN_NUM, 4	# max number of cabin: 4 cabins

    	.set    CCB_SZ, 14		# size of Cabin Control Blocks
    	.set    CCB_PREV, 0		# field 1: previous
    	.set    CCB_NEXT, 2		# field 2: next
    	.set    CCB_CSTACK, 4		# field 3: saved cabin sp
    	.set    CCB_TSTACK, 6		# field 4: saved thread sp
    	.set    CCB_STATUS, 8		# field 5: status
    	.set    CCB_INTFLG, 10		# field 6: interrupt flag, 0/1 dis/en
	.set	CCB_ID, 12		# field 7: ID

    	.set    READY, 0		# Cabin Status
    	.set    DISAB, 0		# Cabin interrupt flag
    	.set    ENABL, 1		# Cabin interrupt flag

	.set    KERNEL_ENTRY, 0x3000	# parameter about kernel
	.set    KERNEL_TIMER, 0x3017	# parameter about kernel
    	.set    TSTACK_SZ, 0x200	# stack seg skip for each OS
    	.set    TSTACK_BOTTOM, 0xfff0	# 0:DS, 2:timer 4:CS 6:EF 8:OS_entry a:CS c:EF
    	.set    TDATA_SEGMENT, 0x0000	# initial data segment for OS
    	.set    TDATA_SZ, 0x100		# data seg skip for each OS
